#include <avr\io.h>
#include <avr\interrupt.h>
#include<string.h>

#define F_CPU 16000000
#include <util/delay.h>
#include <stdlib.h>
#define no_animations 4
unsigned char cube[4][2];
int frame=0;
int animation=0;


void init_cube()
{
	if(animation==0){
		cube[0][0]=0xF0;
		cube[0][1]=0x00;
		cube[1][0]=0x0F;
		cube[1][1]=0x00;
		cube[2][0]=0x00;
		cube[2][1]=0xF0;
		cube[3][0]=0x00;
		cube[3][1]=0x0F;
	}
	else if(animation==1){
		cube[0][0]=0x00;
		cube[0][1]=0x00;
		cube[1][0]=0x00;
		cube[1][1]=0x00;
		cube[2][0]=0x00;
		cube[2][1]=0x00;
		cube[3][0]=0x00;
		cube[3][1]=0x00;
	}else if(animation==2){
		cube[0][0]=0xF9;
		cube[0][1]=0x9F;
		cube[1][0]=0x00;
		cube[1][1]=0x00;
		cube[2][0]=0x00;
		cube[2][1]=0x00;
		cube[3][0]=0x00;
		cube[3][1]=0x00;
	}else if(animation==3){
		cube[0][0]=0xF9;
		cube[0][1]=0x9F;
		cube[1][0]=0x90;
		cube[1][1]=0x09;
		cube[2][0]=0x90;
		cube[2][1]=0x09;
		cube[3][0]=0xF9;
		cube[3][1]=0x9F;
	}
}


void aprinde_led(int coloana){
	if(coloana<8)
		PORTA |=1<<coloana;
	else if (coloana<16)
		PORTB|=1<<(16-coloana);
}


void clear_cube(){
	PORTA=0x00;
	PORTB=0x00;
	PORTC=0x00;
	memset(cube,0,4*2);
}


void initTimer()
{
	// mode: CTC prescaler: 1024
	// configurati timer-ul pentru 1 secunda
	//activati intreruperea
	unsigned int c=3900;
	OCR1A=c;
	TCCR1A = 0;
	TCCR1B |= (1<<CS12);
	//TCCR1B | = (1<<CS10);
	TCCR1B |= (1 << WGM12); 
	TIMSK |= (1 << OCIE1A);
}


ISR(TIMER1_COMPA_vect)
{
	frame++;
	if(animation==0){
		
		if(frame>=6)
			frame=0;
		switch(frame)
		{
			case 0:
				cube[0][0]=0xF0;
				cube[0][1]=0x00;
				cube[1][0]=0x0F;
				cube[1][1]=0x00;
				cube[2][0]=0x00;
				cube[2][1]=0xF0;
				cube[3][0]=0x00;
				cube[3][1]=0x0F;
				break;
			case 1:
				cube[0][0]=0x00;
				cube[0][1]=0x00;
				cube[1][0]=0xFF;
				cube[1][1]=0x00;
				cube[2][0]=0x00;
				cube[2][1]=0xFF;
				cube[3][0]=0x00;
				cube[3][1]=0x00;
				break;
			case 2:
				cube[0][0]=0x00;
				cube[0][1]=0x00;
				cube[1][0]=0x00;
				cube[1][1]=0xFF;
				cube[2][0]=0xFF;
				cube[2][1]=0x00;
				cube[3][0]=0x00;
				cube[3][1]=0x00;
				break;
			case 3:
				cube[0][0]=0x00;
				cube[0][1]=0x0F;
				cube[1][0]=0x00;
				cube[1][1]=0xF0;
				cube[2][0]=0x0F;
				cube[2][1]=0x00;
				cube[3][0]=0xF0;
				cube[3][1]=0x00;
				break;
			case 4:
				cube[0][0]=0x00;
				cube[0][1]=0xF0;
				cube[1][0]=0x00;
				cube[1][1]=0xF0;
				cube[2][0]=0x0F;
				cube[2][1]=0x00;
				cube[3][0]=0x0F;
				cube[3][1]=0x00;
				break;
			case 5:
				cube[0][0]=0x0F;
				cube[0][1]=0x00;
				cube[1][0]=0x0F;
				cube[1][1]=0x00;
				cube[2][0]=0x00;
				cube[2][1]=0xF0;
				cube[3][0]=0x00;
				cube[3][1]=0xF0;
				break;
		}
	}
	else if(animation==1){
		if(frame%3==0){
			frame=1;
			int i;
			
			for(i=0;i<4;i++){
				memcpy(cube[i],cube[i+1],2);
			}
			memset(cube[3],0,2);
			int newdrop=rand()%16;
			cube[3][newdrop>7?1:0]=1<<newdrop%8;
		}
		
	}
	else if(animation==2){
		if(frame%2==0){
			int i;
			for(i=3;i>0;i--){
				memcpy(cube[i],cube[i-1],2);
			}
			memset(cube[0],0,2);
			if(frame>6){
				frame=0;
				init_cube();
			}
			
		}
	}
	
	
}


int main()
{
	TIMSK = 0;
	sei();
	initTimer();
	DDRA |= 0xFF;
	PORTA = 0x00;
	DDRB |= 0xFF;
	PORTB= 0x00;
	DDRC |= 0xFF;
	PORTC = 0x00;
	DDRD &=~(1<<PD6);
	PORTD |= 1<<PD6;
	int i;

	init_cube();
	
	while(1){
		if((PIND & (1<<PD6)) == 0x00)
		{
			_delay_ms(100);
			animation++;
			if(animation>=no_animations)
				animation=0;
			clear_cube();
			init_cube();
			while((PIND & (1<<PD6)) == 0x00);
		}
		for(i=0;i<4;i++){
			PORTA=cube[i][0];
			PORTB=cube[i][1];
			switch(i)
			{
				case 0:
					PORTC=1<<PC0;
					break;
				case 1:
					PORTC=1<<PC1;
					break;
				case 2:
					PORTC=1<<PC6;
					break;
				case 3:
					PORTC=1<<PC7;
					break;
			}
			_delay_ms(5);
		}
		
	}
	return 0;
}